diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index e486c2786..d5b359d1c 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,33 +1,30 @@
 package net.minecraft.client;
 
-import static net.minecraft.core.Global.*;
-import static org.lwjgl.opengl.GL11.*;
-
 import java.io.File;
 import java.io.IOException;
 import java.util.ArrayList;
+import java.util.List;
 import java.util.Comparator;
 import java.util.Random;
 
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.client.entity.ClientSkinVariantList;
+import net.minecraft.client.gui.toasts.GuiHudToasts;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.world.save.*;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeGroups;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.Display;
-
-import com.mojang.nbt.CompoundTag;
-
-import net.minecraft.client.achievement.stat.StatStringFormatKeyInv;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
-import net.minecraft.client.entity.ClientSkinVariantList;
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
-import net.minecraft.client.entity.player.EntityPlayerSP;
-import net.minecraft.client.gui.GuiAchievement;
+import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
 import net.minecraft.client.gui.GuiBadJavaArch;
 import net.minecraft.client.gui.GuiChat;
 import net.minecraft.client.gui.GuiConflictWarning;
 import net.minecraft.client.gui.GuiConnecting;
-import net.minecraft.client.gui.GuiContainer;
 import net.minecraft.client.gui.GuiCreateWorld;
 import net.minecraft.client.gui.GuiException;
 import net.minecraft.client.gui.GuiGameOver;
@@ -53,10 +50,8 @@ import net.minecraft.client.input.MouseInput;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.Joystick;
-import net.minecraft.client.net.handler.NetClientHandler;
-import net.minecraft.client.net.thread.ThreadCheckHasPaid;
+import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.client.net.thread.ThreadDownloadResources;
-import net.minecraft.client.net.thread.ThreadSleepForeverClient;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
@@ -81,41 +76,37 @@ import net.minecraft.client.render.camera.EntityCameraFirstPerson;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.render.window.GameWindow;
 import net.minecraft.client.render.window.GameWindowLWJGL2;
-import net.minecraft.client.sound.SoundManager;
+import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.util.helper.ScreenshotHelper;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.Global;
-import net.minecraft.core.HitResult;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.MinecraftError;
 import net.minecraft.core.MinecraftException;
 import net.minecraft.core.Timer;
 import net.minecraft.core.UnexpectedThrowable;
-import net.minecraft.core.achievement.AchievementList;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.achievement.stat.StatsCounter;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
-import net.minecraft.core.crafting.legacy.CraftingManager;
+import net.minecraft.core.block.BaseLeavesBlock;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.SkinVariantList;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumOS;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.PlayerProfile;
 import net.minecraft.core.net.command.ClientCommandHandler;
@@ -130,7 +121,8 @@ import net.minecraft.core.util.helper.ScreenShot;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.PortalHandler;
 import net.minecraft.core.world.World;
@@ -139,13 +131,30 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.save.ISaveConverter;
-import net.minecraft.core.world.save.ISaveFormat;
-import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.save.LevelStorage;
-import net.minecraft.core.world.save.SaveConverters;
-import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import org.lwjgl.opengl.GL11;
+
+import java.net.HttpURLConnection;
+import java.net.URL;
+
+import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
+import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+import static org.lwjgl.opengl.GL11.glAlphaFunc;
+import static org.lwjgl.opengl.GL11.glClear;
+import static org.lwjgl.opengl.GL11.glClearColor;
+import static org.lwjgl.opengl.GL11.glClearDepth;
+import static org.lwjgl.opengl.GL11.glColor4f;
+import static org.lwjgl.opengl.GL11.glCullFace;
+import static org.lwjgl.opengl.GL11.glDepthFunc;
+import static org.lwjgl.opengl.GL11.glDisable;
+import static org.lwjgl.opengl.GL11.glEnable;
+import static org.lwjgl.opengl.GL11.glLoadIdentity;
+import static org.lwjgl.opengl.GL11.glMatrixMode;
+import static org.lwjgl.opengl.GL11.glOrtho;
+import static org.lwjgl.opengl.GL11.glShadeModel;
+import static org.lwjgl.opengl.GL11.glTranslatef;
+import static org.lwjgl.opengl.GL11.glViewport;
 
 // Referenced classes of package net.minecraft.client:
 //            MinecraftApplet
@@ -163,7 +172,7 @@ public class Minecraft
     private final Timer timer;
     public World theWorld;
     public RenderGlobal renderGlobal;
-    public EntityPlayerSP thePlayer;
+    public LocalPlayer thePlayer;
     public ICamera activeCamera;
     public EffectRenderer effectRenderer;
     public Session session;
@@ -183,13 +192,12 @@ public class Minecraft
     public WorldRenderer worldRenderer;
     public ThreadDownloadResources downloadResourcesThread;
     private int ticksRan;
-    public GuiAchievement guiAchievement;
+    public GuiHudToasts guiAchievementToast;
     public GuiIngame ingameGUI;
     public boolean skipRenderWorld;
-    public ModelBiped field_9242_w;
     public HitResult objectMouseOver;
     public GameSettings gameSettings;
-    public SoundManager sndManager;
+    public SoundEngine sndManager;
     public TexturePackList texturePackList;
     private File mcDataDir;
     private ISaveFormat saveFormat;
@@ -239,18 +247,17 @@ public class Minecraft
         Global.accessor = this;
         LogPrintStream.setup();
         hasCrashed = false;
-        timer = new Timer(20F);
+        timer = new Timer(Global.TICKS_PER_SECOND);
         session = null;
         hideQuitButton = false;
         isGamePaused = false;
         currentScreen = null;
         loadingScreen = new LoadingScreenRenderer(this);
         ticksRan = 0;
-        guiAchievement = new GuiAchievement(this);
+        guiAchievementToast = new GuiHudToasts(this);
         skipRenderWorld = false;
-        field_9242_w = new ModelBiped(0.0F);
         objectMouseOver = null;
-        sndManager = new SoundManager();
+        sndManager = new SoundEngine();
         running = true;
         debug = "";
         isTakingScreenshot = false;
@@ -259,7 +266,22 @@ public class Minecraft
         isRaining = false;
         systemTime = System.currentTimeMillis();
         joinPlayerCounter = 0;
-        new ThreadSleepForeverClient(this, "Timer hack thread");
+        new Thread("Timer hack thread") {
+            {
+                this.setDaemon(true);
+                this.start();
+            }
+
+            @Override
+            public void run() {
+                while (Minecraft.this.running) {
+                    try {
+                        Thread.sleep(2147483647L);
+                    }
+                    catch (final InterruptedException ex) {}
+                }
+            }
+        };
         INSTANCE = this;
     }
 
@@ -338,8 +360,10 @@ public class Minecraft
 		mcDataDir = getMinecraftDir();
 
         // Manually initialize blocks and items
-        Block.initializeBlocks();
-        Item.initializeItems();
+        Blocks.init();
+        Items.init();
+
+        Dimension.init();
 
 		gameSettings = new GameSettings(this, mcDataDir);
 
@@ -396,20 +420,9 @@ public class Minecraft
         ItemModelDispatcher.getInstance();
 
         EntityRenderDispatcher.instance.itemRenderer = new ItemRenderer(this);
-        statsCounter = new StatsCounter(session, mcDataDir);
-        AchievementList.OPEN_INVENTORY.setStatStringFormatter(new StatStringFormatKeyInv(this));
-        AchievementList.OPEN_GUIDEBOOK.setStatStringFormatter(s -> {
-            if(!gameSettings.keyGuidebook.isBound()) {
-                return "Set your guidebook keybind in the controls menu!";
-            }
-            return String.format(s, gameSettings.keyGuidebook.getKeyName());
-        });
-
         loadScreen();	// Update loading screen so it doesn't say no response
-        
-        StatList.init();
 
-        System.out.println("Initizalizing input");
+        System.out.println("Initializing input");
         try {
             InputHandler.init(this);
 
@@ -423,19 +436,19 @@ public class Minecraft
         System.out.println("Setting up OpenGL values...");
         
         OpenGLHelper.checkError("pre startup");
-        glEnable(3553 /*GL_TEXTURE_2D*/);
-        glShadeModel(7425 /*GL_SMOOTH*/);
+        glEnable(GL11.GL_TEXTURE_2D);
+        glShadeModel(GL11.GL_SMOOTH);
         glClearDepth(1.0D);
-        glEnable(2929 /*GL_DEPTH_TEST*/);
+        glEnable(GL11.GL_DEPTH_TEST);
         glDepthFunc(515);
-        glEnable(3008 /*GL_ALPHA_TEST*/);
+        glEnable(GL11.GL_ALPHA_TEST);
         glAlphaFunc(516, 0.1F);
-        glCullFace(1029 /*GL_BACK*/);
-        glMatrixMode(5889 /*GL_PROJECTION*/);
+        glCullFace(GL11.GL_BACK);
+        glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
-        glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        glMatrixMode(GL11.GL_MODELVIEW);
         OpenGLHelper.checkError("startup");
-        sndManager.loadSoundSettings(gameSettings);
+        sndManager.init(gameSettings);
         
         loadScreen();	// Update loading screen so it doesn't say no response
         
@@ -447,7 +460,7 @@ public class Minecraft
         
         System.out.println("Initializing Renderer...");
         
-        TextureRegistry.blockAtlas.bindTexture();
+        TextureRegistry.blockAtlas.bind();
         renderGlobal = new RenderGlobal(this, renderEngine);
         glViewport(0, 0, resolution.width, resolution.height);
         effectRenderer = new EffectRenderer(theWorld, renderEngine);
@@ -469,7 +482,6 @@ public class Minecraft
         DataLoader.loadRecipesFromFile("/recipes/furnace.json");
         DataLoader.loadRecipesFromFile("/recipes/trommel.json");
         DataLoader.loadRecipesFromFile("/recipes/workbench.json");
-        CraftingManager.getInstance().init();
 
         DataLoader.loadDataPacks(this);
 
@@ -482,6 +494,21 @@ public class Minecraft
         System.out.printf("%d item groups.%n",itemGroups);
         System.out.printf("%d recipes in %d groups in %d namespaces.%n",recipes,groups,namespaces);
 
+        StatList.init();
+        statsCounter = new StatsCounter(session, mcDataDir);
+        Achievements.OPEN_INVENTORY.setDescriptionFormatter(s -> {
+            if(!gameSettings.keyInventory.isBound()) {
+                return "Set your inventory keybind in the controls menu!";
+            }
+            return String.format(s, gameSettings.keyInventory.getKeyName());
+        });
+        Achievements.OPEN_GUIDEBOOK.setDescriptionFormatter(s -> {
+            if(!gameSettings.keyGuidebook.isBound()) {
+                return "Set your guidebook keybind in the controls menu!";
+            }
+            return String.format(s, gameSettings.keyGuidebook.getKeyName());
+        });
+
         loadScreen();	// Update loading screen so it doesn't say no response
         
         // Enable Discord Rich Presence
@@ -551,23 +578,23 @@ public class Minecraft
     {
         System.out.println("Drawing Loading Screen...");
         glClear(16640);
-        glMatrixMode(5889 /*GL_PROJECTION*/);
+        glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
         glOrtho(0.0D, resolution.scaledWidthExact, resolution.scaledHeightExact, 0.0D, 1000D, 3000D);
-        glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        glMatrixMode(GL11.GL_MODELVIEW);
         glLoadIdentity();
         glTranslatef(0.0F, 0.0F, -2000F);
         glViewport(0, 0, resolution.width, resolution.height);
         glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
         Tessellator tessellator = Tessellator.instance;
-        glDisable(2896 /*GL_LIGHTING*/);
-        glEnable(3553 /*GL_TEXTURE_2D*/);
-        glDisable(2912 /*GL_FOG*/);
+        glDisable(GL11.GL_LIGHTING);
+        glEnable(GL11.GL_TEXTURE_2D);
+        glDisable(GL11.GL_FOG);
         
         if(mojrand == 0)
-            glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/title/majonk.png"));
+            renderEngine.loadTexture("/assets/minecraft/textures/gui/title/majonk.png").bind();
         else
-            glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/title/mojang.png"));
+            renderEngine.loadTexture("/title/mojang.png").bind();
         
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xffffff);
@@ -584,9 +611,9 @@ public class Minecraft
         
         drawMojangLogoVertices((resolution.scaledWidth - width) / 2, (resolution.scaledHeight - height) / 2, 0, 0, width, height);
         
-        glDisable(2896 /*GL_LIGHTING*/);
-        glDisable(2912 /*GL_FOG*/);
-        glEnable(3008 /*GL_ALPHA_TEST*/);
+        glDisable(GL11.GL_LIGHTING);
+        glDisable(GL11.GL_FOG);
+        glEnable(GL11.GL_ALPHA_TEST);
         glAlphaFunc(516, 0.1F);
         Display.swapBuffers();
     }
@@ -711,10 +738,10 @@ public class Minecraft
         }
         if(guiscreen instanceof GuiMainMenu)
         {
-            statsCounter.func_27175_b();
+            statsCounter.fetchStats();
         }
         if(statsCounter != null){
-            statsCounter.syncStats();
+            statsCounter.saveStats();
         }
         if(guiscreen == null && theWorld == null)
         {
@@ -751,8 +778,8 @@ public class Minecraft
 				e.printStackTrace();
 			}
 			if(statsCounter != null) {
-				statsCounter.func_27175_b();
-				statsCounter.syncStats();
+                statsCounter.fetchStats();
+				statsCounter.saveStats();
 			}
 			System.out.println("Stopping!");
 			try {
@@ -764,7 +791,7 @@ public class Minecraft
 			}catch (Throwable ignored) {
 			}
 			if(sndManager != null) {
-				sndManager.closeMinecraft();	
+				sndManager.destroy();
 			}
 			Mouse.destroy();
 			Keyboard.destroy();
@@ -809,7 +836,7 @@ public class Minecraft
 					long tickStartTime = System.currentTimeMillis();
                     Time.tick();
                     AABB.initializePool();
-                    Vec3d.initializePool();
+                    Vec3.initializePool();
                     
                     if(Display.isCloseRequested()) shutdown();
                     if(isGamePaused && theWorld != null && !(currentScreen instanceof GuiModelViewer))
@@ -854,9 +881,9 @@ public class Minecraft
 
                     OpenGLHelper.checkError("pre render");
                     RenderBlocks.fancyGrass = gameSettings.fancyGraphics.value == 1;
-                    EntityItem.enableItemClumping = gameSettings.enableItemClumping.value;
-                    BlockLeavesBase.enableTreeShadowing = gameSettings.treeShadows.value;
-                    sndManager.updateListenerPosition(thePlayer, timer.partialTicks);
+                    ItemEntity.enableItemClumping = gameSettings.enableItemClumping.value;
+                    BaseLeavesBlock.enableTreeShadowing = gameSettings.treeShadows.value;
+                    sndManager.updateListener(thePlayer, timer.partialTicks);
                     glEnable(GL_TEXTURE_2D);
                     if(theWorld != null)
                     {
@@ -902,7 +929,7 @@ public class Minecraft
                         }
                     }
                     sndManager.setMuted(gameSettings.muteOnLostFocus.value && !Display.isActive());
-                    guiAchievement.updateAchievementWindow();
+                    guiAchievementToast.render(timer.partialTicks);
 
                     Debug.change("post");  // 3
                     renderer.endRenderGame(timer.partialTicks);
@@ -920,9 +947,9 @@ public class Minecraft
                     isGamePaused = !isMultiplayerWorld() && currentScreen != null && currentScreen.pausesGame();
                     while(System.currentTimeMillis() >= currentTime + 1000L)
                     {
-                        debug = fpsCounter + " fps, " + ChunkRenderer.chunksUpdated + " chunk updates";
+                        debug = fpsCounter + " fps, " + ChunkRenderer.updates + " chunk updates";
                         debugFPS = fpsCounter + " fps";
-                        ChunkRenderer.chunksUpdated = 0;
+                        ChunkRenderer.updates = 0;
                         currentTime += 1000L;
                         fpsCounter = 0;
                     }
@@ -979,7 +1006,7 @@ public class Minecraft
         {
             System.gc();
             AABB.deinitializePool();
-            Vec3d.deinitializePool();
+            Vec3.deinitializePool();
         }
         catch(Throwable ignored) { }
         try
@@ -1073,13 +1100,13 @@ public class Minecraft
             int blockZ = objectMouseOver.z;
             Side side = objectMouseOver.side;
             double xPlaced;
-			double yPlaced = objectMouseOver.location.yCoord - objectMouseOver.y;
+			double yPlaced = objectMouseOver.location.y - objectMouseOver.y;
 			if(side.getAxis() == Axis.X) {
-				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+				xPlaced = objectMouseOver.location.x - objectMouseOver.x;
 			}else if(side.getAxis() == Axis.Z) {
-				xPlaced = objectMouseOver.location.zCoord - objectMouseOver.z;
+				xPlaced = objectMouseOver.location.z - objectMouseOver.z;
 			}else {
-				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+				xPlaced = objectMouseOver.location.x - objectMouseOver.x;
 			}
             playerController.continueDestroyBlock(blockX, blockY, blockZ, objectMouseOver.side, xPlaced, yPlaced);
         }
@@ -1096,7 +1123,52 @@ public class Minecraft
         boolean flag = true;
         if(objectMouseOver == null)
         {
-            
+            bridge: if (gameSettings.easyBridge.value){
+                if (clickType == 1) {
+                    if (thePlayer.xRot < 45) {break bridge;}
+                    List<AABB> cubes = thePlayer.world.getCubes(thePlayer, thePlayer.bb.cloneMove(0, -1.0, 0.0));
+                    if (cubes.size() < 1){break bridge;}
+                    AABB cube = cubes.get(0);
+                    if (cube == null){break bridge;}
+                    int blockX = MathHelper.floor(thePlayer.x);
+                    int blockY = MathHelper.floor(thePlayer.y - thePlayer.heightOffset - 0.25);
+                    int blockZ = MathHelper.floor(thePlayer.z);
+                    Direction playerDirection = Direction.getHorizontalDirection(thePlayer);
+                    Side side;
+                    switch (playerDirection){
+                        case NORTH:
+                            side = Side.NORTH;
+                            break;
+                        case SOUTH:
+                            side = Side.SOUTH;
+                            break;
+                        case WEST:
+                            side = Side.WEST;
+                            break;
+                        case EAST:
+                            side = Side.EAST;
+                            break;
+                        default:
+                            break bridge;
+                    }
+
+                    double yPlaced = 0.5d;
+                    double xPlaced = 0.5d;
+                    ItemStack stack = this.thePlayer.inventory.getCurrentItem();
+                    int numItemsInStack = stack == null ? 0 : stack.stackSize;
+                    if (this.playerController.useItemOn(thePlayer, theWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
+                        this.playerController.swingItem(true);
+                    }
+                    if (stack == null) {
+                        break bridge;
+                    }
+                    if (stack.stackSize <= 0) {
+                        this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
+                    } else if (stack.stackSize != numItemsInStack) {
+                        worldRenderer.itemRenderer.updateEquippedItem();
+                    }
+                }
+            }
             if(clickType == 0 && attack)
             {
                 playerController.swingItem(true);
@@ -1123,13 +1195,13 @@ public class Minecraft
             int blockZ = objectMouseOver.z;
             Side side = objectMouseOver.side;
             double xPlaced;
-			double yPlaced = objectMouseOver.location.yCoord - objectMouseOver.y;
+			double yPlaced = objectMouseOver.location.y - objectMouseOver.y;
 			if(side.getAxis() == Axis.X) {
-				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+				xPlaced = objectMouseOver.location.x - objectMouseOver.x;
 			}else if(side.getAxis() == Axis.Z) {
-				xPlaced = objectMouseOver.location.zCoord - objectMouseOver.z;
+				xPlaced = objectMouseOver.location.z - objectMouseOver.z;
 			}else {
-				xPlaced = objectMouseOver.location.xCoord - objectMouseOver.x;
+				xPlaced = objectMouseOver.location.x - objectMouseOver.x;
 			}
 
             if(clickType == 0)
@@ -1191,7 +1263,22 @@ public class Minecraft
 
     private void startCheckPaidThread()
     {
-        (new ThreadCheckHasPaid(this)).start();
+        new Thread(() -> {
+            try
+            {
+                HttpURLConnection httpurlconnection = (HttpURLConnection)(new URL("http://session.minecraft.net/game/joinserver.jsp?user=" + session.username + "&session=" + session.sessionId)).openConnection();
+                httpurlconnection.connect();
+                if(httpurlconnection.getResponseCode() == 400)
+                {
+                    Minecraft.hasPaidCheckTime = System.currentTimeMillis();
+                }
+                httpurlconnection.disconnect();
+            }
+            catch(Exception exception)
+            {
+                exception.printStackTrace();
+            }
+        }).start();
     }
 
     public void runTick()
@@ -1201,7 +1288,7 @@ public class Minecraft
             startCheckPaidThread();
         }
         Debug.push("gui");
-        statsCounter.func_27178_d();
+        statsCounter.tick();
         ingameGUI.updateTick();
         Debug.change("misc");
         worldRenderer.getMouseOver(1.0F);
@@ -1221,11 +1308,8 @@ public class Minecraft
             playerController.tick();
         }
         Debug.change("textureTick");
-        TextureRegistry.blockAtlas.bindTexture();
-        if(!isGamePaused)
-        {
-            renderEngine.updateDynamicTextures();
-        }
+        TextureRegistry.blockAtlas.bind();
+        renderEngine.updateDynamicTextures(isGamePaused);
         Debug.change("misc");
         if(currentScreen == null && thePlayer != null)
         {
@@ -1399,7 +1483,7 @@ public class Minecraft
                             }
                             else if (gameSettings.keyFullbright.isPressEvent())
                             {
-                                NetClientHandler queue = getSendQueue();
+                                ClientPacketHandler queue = getSendQueue();
 
                                 if (queue != null)
                                 {
@@ -1494,8 +1578,8 @@ public class Minecraft
                 }
             }
 
-            boolean breakBlockPressed = gameSettings.keyAttack.isPressed() || (controllerInput != null && controllerInput.buttonZR.isPressed());
-            boolean placeBlockPressed = gameSettings.keyInteract.isPressed() || (controllerInput != null && controllerInput.buttonZL.isPressed());
+            boolean breakBlockPressed = gameSettings.keyAttack.isPressed() || (controllerInput != null && controllerInput.buttonRightTrigger.isPressed());
+            boolean placeBlockPressed = gameSettings.keyInteract.isPressed() || (controllerInput != null && controllerInput.buttonLeftTrigger.isPressed());
 
             if(currentScreen == null)
             {
@@ -1504,6 +1588,7 @@ public class Minecraft
             }
             mineBlocks(0, currentScreen == null && breakBlockPressed && inGameHasFocus);
         }
+        InputHandler.poll();
         if (this.controllerInput != null)
         {
             handleControllerInput();
@@ -1556,7 +1641,7 @@ public class Minecraft
             if(!isGamePaused && theWorld != null)
             {
                 Debug.change("randomDisplayTick");
-                theWorld.randomDisplayUpdates(MathHelper.floor_double(thePlayer.x), MathHelper.floor_double(thePlayer.y), MathHelper.floor_double(thePlayer.z));
+                theWorld.randomDisplayUpdates(MathHelper.floor(thePlayer.x), MathHelper.floor(thePlayer.y), MathHelper.floor(thePlayer.z));
                 Debug.change("misc");
             }
             if(!isGamePaused)
@@ -1640,7 +1725,7 @@ public class Minecraft
 
         // Display Guidebook
         if (gameSettings.keyGuidebook.isPressEvent(currentInputDevice)) {
-            thePlayer.triggerAchievement(AchievementList.OPEN_GUIDEBOOK);
+            thePlayer.triggerAchievement(Achievements.OPEN_GUIDEBOOK);
             thePlayer.displayGUIGuidebook();
             return true;
         }
@@ -1808,7 +1893,6 @@ public class Minecraft
             controllerInput.update();
         }catch (Exception e) {
             e.printStackTrace();
-            InputHandler.controllers.remove(controllerInput);
             controllerInput = null;
             setInputType(InputType.KEYBOARD);
             return;
@@ -1824,11 +1908,11 @@ public class Minecraft
         ControllerInput controller = this.controllerInput;
 
         if(currentScreen == null) {
-            if(controller.buttonZR.pressedThisFrame()) {
+            if(controller.buttonRightTrigger.pressedThisFrame()) {
                 clickMouse(0, true, false);
                 mouseTicksRan = ticksRan;
             }
-            if(controller.buttonZL.pressedThisFrame()) {
+            if(controller.buttonLeftTrigger.pressedThisFrame()) {
                 clickMouse(1, true, false);
                 mouseTicksRan = ticksRan;
             }
@@ -1838,10 +1922,10 @@ public class Minecraft
             if(controller.buttonY.pressedThisFrame() || controller.buttonX.pressedThisFrame()) {
                 displayGuiScreen(getGuiInventory());
             }
-            if(controller.buttonMinus.pressedThisFrame()) {
+            if(controller.buttonBack.pressedThisFrame()) {
                 gameSettings.showPlayerList.value = !gameSettings.showPlayerList.value;
             }
-            if(controller.buttonPlus.pressedThisFrame()) {
+            if(controller.buttonStart.pressedThisFrame()) {
                 displayGuiScreen(new GuiIngameMenu());
             }
             if(controller.digitalPad.up.pressedThisFrame()) {
@@ -1857,10 +1941,10 @@ public class Minecraft
             if(controller.digitalPad.left.pressedThisFrame() && thePlayer.getGamemode().canPlayerFly()) {
                 thePlayer.setNoclip(!thePlayer.noPhysics);
             }
-            if(controller.buttonL.pressedThisFrame()) {
+            if(controller.buttonLeftShoulder.pressedThisFrame()) {
                 thePlayer.inventory.changeCurrentItem(1);
             }
-            if(controller.buttonR.pressedThisFrame()) {
+            if(controller.buttonRightShoulder.pressedThisFrame()) {
                 thePlayer.inventory.changeCurrentItem(-1);
             }
             if(controller.joyLeft.getButton().pressedThisFrame()) {
@@ -1875,7 +1959,7 @@ public class Minecraft
             if(controller.buttonB.pressedThisFrame()) {
                 currentScreen.keyTyped((char)0, Keyboard.KEY_BACK, -1, -1);
             }
-            if(controller.buttonPlus.pressedThisFrame()) {
+            if(controller.buttonStart.pressedThisFrame()) {
                 currentScreen.keyTyped((char)0, Keyboard.KEY_ESCAPE, -1, -1);
             }
             if(controller.buttonA.pressedThisFrame()) {
@@ -1905,15 +1989,17 @@ public class Minecraft
 
     private void forceReload()
     {
+        long start = System.nanoTime();
         System.out.println("FORCING RELOAD!");
-        sndManager = new SoundManager();
-        sndManager.loadSoundSettings(gameSettings);
+        sndManager = new SoundEngine();
+        sndManager.init(gameSettings);
         downloadResourcesThread.reloadResources();
         renderEngine.refreshTexturesAndDisplayErrors();
         renderer.reload();
         if (renderGlobal != null){
             renderGlobal.loadRenderers();
         }
+        System.out.println("RELOAD TOOK '" + (System.nanoTime() - start)/ 1_000_000_000d + "' SECONDS!");
     }
 
     public boolean isMultiplayerWorld()
@@ -1922,6 +2008,11 @@ public class Minecraft
     }
 
     public void startWorld(String worldDirName, String worldName, long seed)
+    {
+        startWorld(worldDirName, worldName, seed, null);
+    }
+
+    public void startWorld(String worldDirName, String worldName, long seed, WorldTypeGroups.Group worldTypeGroup)
     {
         changeWorld(null);
         System.gc();
